<?
include_once('gnuplot.php'); 

/*************************************************************************************/
/* Config */
/*************************************************************************************/
$resourcesDir = "/res/";

$baseDir = $_SERVER["DOCUMENT_ROOT"].$resourcesDir;
$incomingDir = $baseDir."incoming/";
$archiveDir  = $baseDir."archive/";
$dataDir  = $baseDir."data/";
$gnuplotdataDir = $dataDir."gnuplot/";
$pngDir = $dataDir."png/";
$tagDir = $dataDir."tag/";
$imageLinkDir = substr($pngDir, strlen($_SERVER["DOCUMENT_ROOT"]));

$dirs = array();
array_push($dirs, $baseDir);
array_push($dirs, $incomingDir);
array_push($dirs, $archiveDir);
array_push($dirs, $dataDir);
array_push($dirs, $gnuplotdataDir);
array_push($dirs, $pngDir);
array_push($dirs, $tagDir);
		
$SPALTE_LEISTUNG_A = 10;
$SPALTE_LEISTUNG_B = 11;
$SPALTE_ENERGIE = 12;

$SPALTE_STATUS_FEHLER = 18;
		
// falls die Verzechnisse noch nicht existieren werden diese erstellt
foreach ($dirs as $dir) {
	if (!file_exists($dir)) {
		echo "Erstelle Directory: $dir<br>";
		if (!mkdir($dir)) {
			die("Fehler beim erstellen des Verzeichnisses $dir");
		}
	}
}

/*************************************************************************************/
/* Funktionen */
/*************************************************************************************/

// gibt alle Dateien / Verzeichnisse aus $dir zurück
function getFilesInDir($dir) {
//	echo "Durchsuche Verzeichnis $dir<br>";
	$files  = array();
	$dir_handle = opendir($dir);
	while ($filename = readdir($dir_handle)) {
		if ($filename == "." || $filename == "..") continue;
		array_push($files, $filename);
	}
	closedir($dir_handle);
	return $files;
}

// liest ein Sunny-Data-Log-File ein
// + Umwandlung Komma -> Punkt
// + erstellen der Beschreibungsdatei (Tag)
// + ins Archiv kopieren und löschen
function convertRawFile($rawFile) {
	global $incomingDir;
	global $archiveDir;
	global $gnuplotdataDir;
	global $tagDir;
	global $SPALTE_LEISTUNG_A;
	global $SPALTE_LEISTUNG_B;
	global $SPALTE_ENERGIE;
	
	
	$rawFileName = $incomingDir.basename($rawFile);
	$gnuFileName = $gnuplotdataDir.basename($rawFile);
	$tagFileName = $tagDir.basename($rawFile);
	$archiveFileName = $archiveDir.basename($rawFile);
	
	if (($handleRaw = fopen ($rawFileName, "r")) === FALSE) {
		die("Konnte Quell-Datei $rawFileName nicht öffnen!");
	}
	if (($handleGnu = fopen ($gnuFileName, "w")) === FALSE) {
		die("Konnte GnuPlot-Datei $gnuFileName nicht öffnen!");
	}
	if (($handleTag = fopen ($tagFileName, "w")) === FALSE) {
		die("Konnte Tag-Datei $tagFileName nicht öffnen!");
	}
	
	
	$zeile = 0;
	$startEnergie = 0;
	$endEnergie = 0;
	$maxLeistung = 0;
	while (!feof($handleRaw)) {
		$buffer = fgets($handleRaw, 4096);
		if ($zeile == 0) {
			// erste Zeile auskommentieren
			$buffer = "#".$buffer;
		}
		// konvertieren zu Gnuplot Data
		$newLine = str_replace(",", ".", $buffer);
		fputs($handleGnu, $newLine);
		// TagData erfassen
		if (($zeile != 0) && ($newLine != "")) {
			$data = split("\t", $newLine);
			if ($zeile == 1) {
				$startEnergie = $data[$SPALTE_ENERGIE];
			}
			$maxLeistung = max($maxLeistung, $data[$SPALTE_LEISTUNG_A] + $data[$SPALTE_LEISTUNG_B]);
			$endEnergie = $data[$SPALTE_ENERGIE];
		}
		$zeile++;
	}	
	
	if ($zeile < 2) {
		die("zu wenig Zeilen in $rawFile");
	}
	
	fputs($handleTag, $endEnergie - $startEnergie."\n");
	fputs($handleTag, $maxLeistung);
	
	fclose($handleRaw);
	fclose($handleGnu);
	fclose($handleTag);
	
//	echo ("Kopiere $rawFileName -> $archiveFileName<br>");
	if (!copy($rawFileName, $archiveFileName)) {
		die("Kopieren fehlgeschlagen: $rawFileName -> $archiveFileName");
	}
	unlink($rawFileName);
}

// wandelt einen Dateinamen in ein gültigen Datums String
function extractDate($filename) {
	$base = basename($filename);
	return (substr($base, 8,2).".".substr($base, 5,2).".".substr($base, 0,4));
}

// füllt einen String mit führenden Nullen auf
function fillZero($string, $length) {
	while (strlen($string) < $length) {
		$string = "0" . $string;
	}
	return $string;
}

// erstellt aus den Monatsdaten-Tags das Monatsdiagramm
function createYearPng($year) {
	$outputName = $year.".txt.png";
//	echo "Erstelle JahrePNG: $outputName<br>";
	global $gnuplotdataDir;
	global $pngDir;
	global $tagDir;
	$tagFileName = $tagDir.basename($year."-".fillZero($month,2).".txt");
//	echo("Monatsfilename: $tagFileName<br>\n");
	
	$data = new PGData('Monatsleistung');

	$monatsEnergie = 0;
	$maximaleEnergie = 0;
	$anzahlTage = 0;
	
	$dataFiles = getFilesInDir($tagDir);
	foreach ($dataFiles as $filename) {
		if (strlen($filename) != 11) continue;
		$path_parts = pathinfo($filename);
		if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "txt")) != 0)) {
			continue;
		}
		$name = basename($filename);
		if ((0 + substr($name,0,4)) != $year) {
			continue;
		}
		
		$month = substr($name, 5,2);

	
		$fileData = file($tagDir.basename($filename));
		
//		echo "$month:".$fileData[0]."<br>";
		
		$data->addDataEntry( array($month, $fileData[0]) );
		
		$jahresEnergie += $fileData[0];
		$anzahlMonate++;
//		echo ("TagEnergie: $filename: $fileData[0]<br>");
		if ((0 + $fileData[0]) > (0 + $maximaleEnergie)) {
			$maximaleEnergie = $fileData[0];
		}
//		echo "$tag: Gesemtenergie:".sprintf("%.3f", $fileData[0])."<br>";
	}
	
	$yearFileName = $tagDir.basename($year.".txt");
	
	if (($handleTag = fopen ($yearFileName, "w")) === FALSE) {
		die("Konnte Tag-Datei $tagFileName nicht öffnen!");
	}
	
	fputs($handleTag, $jahresEnergie."\n");
	fputs($handleTag, $maximaleEnergie."\n");
	
	fclose($handleTag);
	
	$p = new GNUPlot();
	
	$p->set('contour');
	$p->setTitle("Jahresdiagramm $year");
//	$p->set('boxwidth 0.75');
	$p->set('boxwidth 0.5');
	$p->set('style fill solid 1');
	$p->setRange('x', 0, 13); 
//	$p->set('xtics 1,1,12'); 
//	$p->set('format x "%g"');
//	$p->set('xtics ("Jan" 1 ,"Feb" 2,"Maerz" 3, "Apr" 4, "Mai" 5, "Juni" 6, "Juli" 7, "Aug" 8, "Sept" 9, "Okt" 10, "Nov" 11, "Dez" 12)');
	$p->set('xtics ("Januar" 1 ,"Februar" 2,"Maerz" 3, "April" 4, "Mai" 5, "Juni" 6, "Juli" 7, "August" 8, "September" 9, "Oktober" 10, "November" 11, "Dezember" 12)');
//	$p->set('xtics ("1","","2","","asd")');
//	$p->set('xtics ("1" 1, "medium" 15, "30" 31) ');
//	$p->set('mxtics 2'); 
//	$p->exe('show mxtics'); 
	$p->setRange('y', 0, 700); 
	$p->set('ylabel "Gesamtenergie [kWh]"');
//	$p->exe("unset key\n");
	$p->plotData( $data, 'boxes', '1:($2)' ); 
    $data = new PGData('mittlere Montatsleistung des Jahres');
	$avg = $jahresEnergie / $anzahlMonate ;
//	echo "avg = $avg";
	$data->addDataEntry( array(0, $avg) );
    $data->addDataEntry( array(13, $avg) );
    $p->plotData( $data, 'line', '1:($2)' );

	$p->setSize(1, 1);
	$p->export($pngDir.$outputName, "small size 960,360 xffffff x000000 xffb400 xffb400 xff0000 xffb400 xffb400");
	$p->close(); 

}

// erstellt aus den Monatsdaten-Tags das Monatsdiagramm
function createMonthPng($month, $year) {
	$outputName = $year."-".fillZero($month,2).".txt.png";
//	echo "Erstelle Tages MonthPNG: $outputName<br>";
	global $gnuplotdataDir;
	global $pngDir;
	global $tagDir;
	$tagFileName = $tagDir.basename($year."-".fillZero($month,2).".txt");
//	echo("Monatsfilename: $tagFileName<br>\n");
	
	$data = new PGData('Tagesleistung');

	$monatsEnergie = 0;
	$maximaleEnergie = 0;
	$anzahlTage = 0;
	
	$dataFiles = getFilesInDir($tagDir);
	foreach ($dataFiles as $filename) {
		if (strlen($filename) != 14) continue;
		$path_parts = pathinfo($filename);
		if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "txt")) != 0)) {
			continue;
		}
		$name = basename($filename);
		if (((0 + substr($name,0,4)) != $year) || ((0 + substr($name, 5,2)) != $month)) {
			continue;
		}
//		echo ("WORKING\n<br>");
	
		$fileData = file($tagDir.basename($filename));
		
		$tag = substr(basename($filename),8,2);
		
		$data->addDataEntry( array($tag, $fileData[0]) );
		
		$monatsEnergie += $fileData[0];
		$anzahlTage++;
//		echo ("TagEnergie: $filename: $fileData[0]<br>");
		if ((0 + $fileData[0]) > (0 + $maximaleEnergie)) {
			$maximaleEnergie = $fileData[0];
		}
//		echo "$tag: Gesemtenergie:".sprintf("%.3f", $fileData[0])."<br>";
	}
	
//	echo "Monatsenergie: ".sprintf("%.3f", $monatsEnergie)."<br>";
	
	if (($handleTag = fopen ($tagFileName, "w")) === FALSE) {
		die("Konnte Tag-Datei $tagFileName nicht öffnen!");
	}
	
	fputs($handleTag, $monatsEnergie."\n");
	fputs($handleTag, $maximaleEnergie."\n");
	
	fclose($handleTag);

	$p = new GNUPlot();
	
	$p->set('contour');
	$p->setTitle("Monatsdiagramm ".fillZero($month,2)."-$year");
	$p->set('boxwidth 0.75');
	$p->set('style fill solid 1');
	$p->setRange('x', 0, 32); 
	$p->set('xtics 1,1,31'); 
	$p->set('format x "%g"');
//	$p->set('xtics ("1","","2","","asd")');
//	$p->set('xtics ("1" 1, "medium" 15, "30" 31) ');
//	$p->set('mxtics 2'); 
//	$p->exe('show mxtics'); 
	$p->setRange('y', 0, 35); 
	$p->set('ylabel "Gesamtenergie [kWh]"');
//	$p->exe("unset key\n");
	$p->plotData( $data, 'boxes', '1:($2)' ); 
    $data = new PGData('mittlere Tagesleistung des Monats');
	$avg = $monatsEnergie / $anzahlTage ;
//	echo "avg = $avg";
	$data->addDataEntry( array(0, $avg) );
    $data->addDataEntry( array(32, $avg) );
    $p->plotData( $data, 'line', '1:($2)' );

	$p->setSize(1, 1);
	$p->export($pngDir.$outputName, "small size 960,360 xffffff x000000 xffb400 xffb400 xff0000 xffb400 xffb400");
	$p->close(); 

}

// erstellt aus den Tagesdate ein Tagesdiagramm
function createDayPng($filename) {
//	echo "Erstelle Tages PNG: $filename<br>";
	global $gnuplotdataDir;
	global $pngDir;
	global $SPALTE_LEISTUNG_A;
	global $SPALTE_LEISTUNG_B;
	global $SPALTE_ENERGIE;
	
	$sourceFileName = $gnuplotdataDir.basename($filename);
	$pngFileName = $pngDir.basename($filename).".png";
	
	if (($handleSrc = fopen ($sourceFileName, "r")) === FALSE) {
		die("Konnte Quell-Datei $rawFileName nicht öffnen!");
	}
	
	$startValue = 0;
	
	while (!feof($handleSrc)) {
		$buffer = fgets($handleSrc, 4096);
		if (($buffer == "") || ($buffer[0] == "#")) {
			continue;
		}
		$data = split("\t", $buffer);
		$startValue = $data[$SPALTE_ENERGIE];
//		echo "Startwert $startValue<br>";
		break;
	}
	
	fclose($handleSrc);

	$p = new GNUPlot();
	
	$p->set('contour');
	$p->setTitle("Tagesdiagramm vom ".extractDate($filename));
	$p->setRange('y', 0, 5000); 
	$p->setRange('y2', 0, 35); 
	$p->set('datafile separator "\t"');
	$p->set("xdata time");
	$p->set('timefmt "%d.%m.%Y %H:%M:%S"');
	$p->set('xrange ["'.extractDate($filename).' 05:00":"'.extractDate($filename).' 22:00"]'); 
	$p->set('format x "%H:%M"');
	$p->set('y2tics');
	$p->set('ylabel "Leistung [W]"');
	$p->set('y2label "Energie [kWh]"');
	$p->set('key top left');
	//$p->exe("splot x*y\n");
	$data = PGData::createFromFile($sourceFileName, 'Leistung (in W)');
// //	$p->plotData( $data, 'lines', '1:($'.($SPALTE_LEISTUNG_A+1).'+$'.($SPALTE_LEISTUNG_B+1).'):12' ); 
//	$p->exe("plot '$data' using 1:($".($SPALTE_LEISTUNG_A+1)."+$".($SPALTE_LEISTUNG_B+1)." title \"Gesamtleistung\" with lines\n"); 
	$execString = "plot '$sourceFileName' ";

//	$execString .= "using 1:(($".($SPALTE_LEISTUNG_A+1)."+$".($SPALTE_LEISTUNG_B+1).")/2) title \"Durchschnitt\" with lines";
	$execString .= "using 1:(($".($SPALTE_LEISTUNG_A+1)."+$".($SPALTE_LEISTUNG_B+1).")) title \"Gesamtleistung\" with lines";
	$execString .= ", '$sourceFileName' ";
	$execString .= "using 1:".($SPALTE_LEISTUNG_A+1)." title \"Kanal A\" with dots";
	$execString .= ", '$sourceFileName' ";
	$execString .= "using 1:".($SPALTE_LEISTUNG_B+1)." title \"Kanal B\" with dots";
	$execString .= ", '$sourceFileName' ";
	$execString .= "using 1:($".($SPALTE_ENERGIE+1)."-$startValue) title \"Energie\" with lines axis x1y2\n";

	$p->exe($execString);
	$p->setSize(1, 1);
	$p->export($pngFileName, "small size 480,360");
	$p->export($pngFileName.".big.png", "medium size 960,720");
	$p->close(); 
}

/*************************************************************************************/
/* Hauptcode */
/*************************************************************************************/
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
		<title>Solaranlage</title>
		<meta name="author" content="Snubnose">
		<meta http-equiv="content-type" content="text/html; charset=utf8">
		<meta http-equiv="content-language" content="de">
		<script type="text/javascript">
			// <!--
			function getmailaddress(user,domain)
			{
				url="mail";
				url=url+"to:";
				url=url+user+"@"+domain;
				window.location.href=url;
			}
				// -->
		</script>
	</head>
	<body>
<?
// wenn der URL index.php?rebuild=true
// übergeben wird werden alle Daten neu erstellt
if ($_GET["rebuild"]) {
	$incoming = getFilesInDir($archiveDir);
	foreach ($incoming as $filename) {
		$path_parts = pathinfo($filename);
		if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "txt")) != 0)) {
//		if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "bz2")) != 0)) {
			continue;
		}
		echo ("rebuild: ".$archiveDir.basename($filename)."<br>");
		copy($archiveDir.basename($filename),$incomingDir.basename($filename));
	}
}

if ($_GET["test"]) {
	$incoming = getFilesInDir($archiveDir);
	rsort($incoming);
	$cnt = 0;
	foreach ($incoming as $filename) {
		$path_parts = pathinfo($filename);
		if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "txt")) != 0)) {
//		if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "bz2")) != 0)) {
			continue;
		}
		echo ("rebuild: ".$archiveDir.basename($filename)."<br>");
		copy($archiveDir.basename($filename),$incomingDir.basename($filename));
		if (++$cnt == 2) break;
	}
}


// Entpacken der einkommenden Dateien
$incoming = getFilesInDir($incomingDir);
foreach ($incoming as $filename) {
	$path_parts = pathinfo($filename);
	if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "bz2")) != 0)) {
		continue;
	}
	system("/usr/bin/bunzip2 -f $incomingDir".basename($filename), $ret);
	if ( $ret != 0) {
		echo "Fehler beim Entpacken mit bunzip!<br>\n";
	};
}

$changed = array();

// aus neuen Dateien neue Tagesdiagramme erstellen
$incoming = getFilesInDir($incomingDir);
foreach ($incoming as $filename) {
	$path_parts = pathinfo($filename);
	if ((!array_key_exists("extension", $path_parts)) || ((strcmp(strtolower($path_parts["extension"]), "txt")) != 0)) {
		continue;
	}
	convertRawFile($filename);
	createDayPng($filename);
	array_push($changed,basename($filename));
}

// veränderte Monatsdaten feststellen
$changedMonths = array();
foreach ($changed as $day) {
	array_push($changedMonths, substr($day,0,7));
}

// Monatdiagramme erstellen
$changedMonths = array_unique($changedMonths);
foreach ($changedMonths as $month) {
	$m = substr($month, 5,2);
	$y = substr($month, 0,4);
	createMonthPng($m,$y);
}

// veränderte Jahresdaten feststellen
$changedYears = array();
foreach ($changed as $day) {
	array_push($changedYears, substr($day,0,4));
}

// Jahresdiagramme erstellen
$changedYears = array_unique($changedYears);
foreach ($changedYears as $year) {
	$y = substr($year, 0,4);
	createYearPng($y);
}


// verfügbare Daten einlesen
$dataFiles = getFilesInDir($gnuplotdataDir);
rsort($dataFiles);

// ANZEIGE letzten zwei verfügbare Tage anzeigen
echo "<table><tr>";
for ($cnt = 1; $cnt >= 0; $cnt--) {
	echo "<td>";
	$data = $dataFiles[$cnt];
	echo '<a href="'.$imageLinkDir.basename($data).'.png.big.png"><img src="'.($imageLinkDir.basename($data)).'.png" border="0"></a><br>';
	$tag = file($tagDir.basename($data));
	echo "<table  style=\"font-size:small;\">";
	echo "<tr><td>Maximale Leistung:</td><td align=right>&nbsp;&nbsp;$tag[1]</td><td>W</td></tr>";
	echo "<tr><td>Gesamtenergie:</td><td align=right>&nbsp;&nbsp;".sprintf("%.2f", $tag[0])."</td><td>kWh</td></tr>";
	echo "</table>";
	echo "</td>";
}
echo "</tr></table>";

echo "<hr>";

$dataFiles = getFilesInDir($tagDir);
rsort($dataFiles);
foreach($dataFiles as $dataFile) {
	// nur Jahresdaten nehmen
	if (strlen($dataFile) != 8) continue;
	echo '<img src="'.$imageLinkDir.basename($dataFile).'.png"><br>';
	echo "<table  style=\"font-size:small;\">";
	$tag = file($tagDir.basename($dataFile));
	echo "<tr><td>Maximale Monatsleistung:</td><td align=right>&nbsp;&nbsp;".sprintf("%.2f", $tag[1])."</td><td>kWh</td></tr>";
	echo "<tr><td>Gesamtenergie:</td><td align=right>&nbsp;&nbsp;".sprintf("%.2f", $tag[0])."</td><td>kWh</td></tr>";
	echo "</table>";
	echo "</td>";
	//break;
}
echo "<hr>";

// ANZEIGE Montsdaten
$dataFiles = getFilesInDir($tagDir);
rsort($dataFiles);
$cnt = 0;
foreach($dataFiles as $dataFile) {
	// nur Monatsdaten nehmen
	if (strlen($dataFile) != 11) continue;
	$cnt++;
	if ((!($_GET["showall"] || $_GET["showallmonths"])) && ($cnt == 13)) {
		break;
	}
	echo '<img src="'.$imageLinkDir.basename($dataFile).'.png"><br>';
	echo "<table  style=\"font-size:small;\">";
	$tag = file($tagDir.basename($dataFile));
	echo "<tr><td>Maximale Tagesleistung:</td><td align=right>&nbsp;&nbsp;".sprintf("%.2f", $tag[1])."</td><td>kWh</td></tr>";
	echo "<tr><td>Gesamtenergie:</td><td align=right>&nbsp;&nbsp;".sprintf("%.2f", $tag[0])."</td><td>kWh</td></tr>";
	echo "</table>";
	echo "</td>";
}
if (!$_GET["showallmonths"]) {
	echo '<p><a href="'.$_SERVER["PHP_SELF"].'?showallmonths=true">alle Monatsdiagramme anzeigen';
}

echo "<hr>alle Daten:<br>";
$dataFiles = getFilesInDir($gnuplotdataDir);
rsort($dataFiles);
echo "<table>";


// alle Tagesdiagramme anzeigen
$cnt = 0;
foreach ($dataFiles as $data) {
	$cnt++;
	if ((!($_GET["showall"])) && ($cnt == 32)) {
		break;
	}
	echo "<tr><td>";
	echo '<a href="'.$imageLinkDir.basename($data).'.png.big.png"><img src="'.($imageLinkDir.basename($data)).'.png" border="0"></a><br>';
	$tag = file($tagDir.basename($data));
	echo "<table  style=\"font-size:small;\">";
	echo "<tr><td>Maximale Leistung:</td><td align=right>&nbsp;&nbsp;$tag[1]</td><td>W</td></tr>";
	echo "<tr><td>Gesamtenergie:</td><td align=right>&nbsp;&nbsp;".sprintf("%.2f", $tag[0])."</td><td>kWh</td></tr>";
	echo "</table>";
	echo "</td></tr>";
}
echo "</table>";

if (!$_GET["showall"]) {
	echo '<p><a href="'.$_SERVER["PHP_SELF"].'?showall=true">alle Tagesdiagramme anzeigen';
}


?> 
</body></html>

